commit 351cc920d8a75748f082340eb4291914a1f56afc
Author: Andrea Corallo <andrea.corallo@arm.com>
Date:   Mon Oct 10 11:59:58 2022

    arm: improve tests and fix vcmp*
    
    gcc/ChangeLog:
    
            * config/arm/mve.md (@mve_vcmp<mve_cmp_op>q_<mode>): Fix
            spacing.
            * config/arm/arm_mve.h (__arm_vcmpgtq_m, __arm_vcmpleq_m)
            (__arm_vcmpltq_m, __arm_vcmpneq_m): Add missing defines.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u16.c: Improve test.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_m_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpcsq_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_m_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpeqq_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgeq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpgtq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_m_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmphiq_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpleq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpltq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_m_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_f16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_f32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_n_u8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_s16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_s32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_s8.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_u16.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_u32.c: Likewise.
            * gcc.target/arm/mve/intrinsics/vcmpneq_u8.c: Likewise.
    
    (cherry picked from commit 1fa5a44736062eeccd241ebeb1771bd77b7fd168)

diff --git a/gcc/config/arm/arm_mve.h b/gcc/config/arm/arm_mve.h
index 073e3711623..684f997520f 100644
--- a/gcc/config/arm/arm_mve.h
+++ b/gcc/config/arm/arm_mve.h
@@ -39229,6 +39229,53 @@ extern void *__ARM_undef;
   int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int_n]: __arm_vcmpgeq_m_n_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16_t), p2), \
   int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int_n]: __arm_vcmpgeq_m_n_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32_t), p2));})
 
+
+#define __arm_vcmpgtq_m(p0,p1,p2) ({ __typeof(p0) __p0 = (p0); \
+  __typeof(p1) __p1 = (p1); \
+  _Generic( (int (*)[__ARM_mve_typeid(__p0)][__ARM_mve_typeid(__p1)])0, \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int8x16_t]: __arm_vcmpgtq_m_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8x16_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int16x8_t]: __arm_vcmpgtq_m_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16x8_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int32x4_t]: __arm_vcmpgtq_m_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32x4_t), p2), \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int_n]: __arm_vcmpgtq_m_n_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int_n]: __arm_vcmpgtq_m_n_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int_n]: __arm_vcmpgtq_m_n_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32_t), p2));})
+
+#define __arm_vcmpleq_m(p0,p1,p2) ({ __typeof(p0) __p0 = (p0); \
+  __typeof(p1) __p1 = (p1); \
+  _Generic( (int (*)[__ARM_mve_typeid(__p0)][__ARM_mve_typeid(__p1)])0, \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int8x16_t]: __arm_vcmpleq_m_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8x16_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int16x8_t]: __arm_vcmpleq_m_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16x8_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int32x4_t]: __arm_vcmpleq_m_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32x4_t), p2), \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int_n]: __arm_vcmpleq_m_n_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int_n]: __arm_vcmpleq_m_n_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int_n]: __arm_vcmpleq_m_n_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32_t), p2));})
+
+#define __arm_vcmpltq_m(p0,p1,p2) ({ __typeof(p0) __p0 = (p0); \
+  __typeof(p1) __p1 = (p1); \
+  _Generic( (int (*)[__ARM_mve_typeid(__p0)][__ARM_mve_typeid(__p1)])0, \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int8x16_t]: __arm_vcmpltq_m_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8x16_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int16x8_t]: __arm_vcmpltq_m_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16x8_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int32x4_t]: __arm_vcmpltq_m_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32x4_t), p2), \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int_n]: __arm_vcmpltq_m_n_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int_n]: __arm_vcmpltq_m_n_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int_n]: __arm_vcmpltq_m_n_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32_t), p2));})
+
+#define __arm_vcmpneq_m(p0,p1,p2) ({ __typeof(p0) __p0 = (p0); \
+  __typeof(p1) __p1 = (p1); \
+  _Generic( (int (*)[__ARM_mve_typeid(__p0)][__ARM_mve_typeid(__p1)])0, \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int8x16_t]: __arm_vcmpneq_m_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8x16_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int16x8_t]: __arm_vcmpneq_m_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16x8_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int32x4_t]: __arm_vcmpneq_m_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32x4_t), p2), \
+  int (*)[__ARM_mve_type_uint8x16_t][__ARM_mve_type_uint8x16_t]: __arm_vcmpneq_m_u8 (__ARM_mve_coerce(__p0, uint8x16_t), __ARM_mve_coerce(__p1, uint8x16_t), p2), \
+  int (*)[__ARM_mve_type_uint16x8_t][__ARM_mve_type_uint16x8_t]: __arm_vcmpneq_m_u16 (__ARM_mve_coerce(__p0, uint16x8_t), __ARM_mve_coerce(__p1, uint16x8_t), p2), \
+  int (*)[__ARM_mve_type_uint32x4_t][__ARM_mve_type_uint32x4_t]: __arm_vcmpneq_m_u32 (__ARM_mve_coerce(__p0, uint32x4_t), __ARM_mve_coerce(__p1, uint32x4_t), p2), \
+  int (*)[__ARM_mve_type_int8x16_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_s8 (__ARM_mve_coerce(__p0, int8x16_t), __ARM_mve_coerce(__p1, int8_t), p2), \
+  int (*)[__ARM_mve_type_int16x8_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_s16 (__ARM_mve_coerce(__p0, int16x8_t), __ARM_mve_coerce(__p1, int16_t), p2), \
+  int (*)[__ARM_mve_type_int32x4_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_s32 (__ARM_mve_coerce(__p0, int32x4_t), __ARM_mve_coerce(__p1, int32_t), p2), \
+  int (*)[__ARM_mve_type_uint8x16_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_u8 (__ARM_mve_coerce(__p0, uint8x16_t), __ARM_mve_coerce(__p1, uint8_t), p2), \
+  int (*)[__ARM_mve_type_uint16x8_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_u16 (__ARM_mve_coerce(__p0, uint16x8_t), __ARM_mve_coerce(__p1, uint16_t), p2), \
+  int (*)[__ARM_mve_type_uint32x4_t][__ARM_mve_type_int_n]: __arm_vcmpneq_m_n_u32 (__ARM_mve_coerce(__p0, uint32x4_t), __ARM_mve_coerce(__p1, uint32_t), p2));})
+
 #define __arm_vdupq_m(p0,p1,p2) ({ __typeof(p0) __p0 = (p0); \
   __typeof(p1) __p1 = (p1); \
   _Generic( (int (*)[__ARM_mve_typeid(__p0)][__ARM_mve_typeid(__p1)])0, \
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u16.c
index a1640133012..de9fe5e7d01 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u16.c
@@ -1,22 +1,63 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint16x8_t a, uint16_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_n_u16 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u16"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint16x8_t a, uint16_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/*
+**foo2:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint16x8_t a, mve_pred16_t p)
+{
+  return vcmpcsq_m (a, 1, p);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u32.c
index d269ec7e3ab..04df1b2dc61 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u32.c
@@ -1,22 +1,63 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint32x4_t a, uint32_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_n_u32 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u32"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint32x4_t a, uint32_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/*
+**foo2:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint32x4_t a, mve_pred16_t p)
+{
+  return vcmpcsq_m (a, 1, p);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u8.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u8.c
index 52c16b3e70f..34ebadca248 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u8.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_n_u8.c
@@ -1,22 +1,63 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint8x16_t a, uint8_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_n_u8 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u8"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint8x16_t a, uint8_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/*
+**foo2:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint8x16_t a, mve_pred16_t p)
+{
+  return vcmpcsq_m (a, 1, p);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u16.c
index e68afa316a9..bc03bf687de 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u16.c
@@ -1,22 +1,45 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u16	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint16x8_t a, uint16x8_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_u16 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u16"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u16	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint16x8_t a, uint16x8_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u32.c
index 05d1b21b279..8e216d49a02 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u32.c
@@ -1,22 +1,45 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u32	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint32x4_t a, uint32x4_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_u32 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u32"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u32	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint32x4_t a, uint32x4_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u8.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u8.c
index 4c8a9d0aa2c..ac4196a2e48 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u8.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_m_u8.c
@@ -1,22 +1,45 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u8	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint8x16_t a, uint8x16_t b, mve_pred16_t p)
 {
   return vcmpcsq_m_u8 (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
-/* { dg-final { scan-assembler "vcmpt.u8"  }  } */
 
+/*
+**foo1:
+**	...
+**	vmsr	p0, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vpst(?:	@.*|)
+**	...
+**	vcmpt.u8	cs, q[0-9]+, q[0-9]+(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint8x16_t a, uint8x16_t b, mve_pred16_t p)
 {
   return vcmpcsq_m (a, b, p);
 }
 
-/* { dg-final { scan-assembler "vpst" } } */
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u16.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u16.c
index 4124036003e..6038f4c8c65 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u16.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u16.c
@@ -1,21 +1,51 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vcmp.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint16x8_t a, uint16_t b)
 {
   return vcmpcsq_n_u16 (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u16"  }  } */
 
+/*
+**foo1:
+**	...
+**	vcmp.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint16x8_t a, uint16_t b)
 {
   return vcmpcsq (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u16"  }  } */
+/*
+**foo2:
+**	...
+**	vcmp.u16	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint16x8_t a)
+{
+  return vcmpcsq (a, 1);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u32.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u32.c
index 463c1ee12b4..9f39aa761c8 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u32.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u32.c
@@ -1,21 +1,51 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vcmp.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint32x4_t a, uint32_t b)
 {
   return vcmpcsq_n_u32 (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u32"  }  } */
 
+/*
+**foo1:
+**	...
+**	vcmp.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint32x4_t a, uint32_t b)
 {
   return vcmpcsq (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u32"  }  } */
+/*
+**foo2:
+**	...
+**	vcmp.u32	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint32x4_t a)
+{
+  return vcmpcsq (a, 1);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
diff --git a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u8.c b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u8.c
index 92bc44a4bb6..0ce2cd13a7b 100644
--- a/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u8.c
+++ b/gcc/testsuite/gcc.target/arm/mve/intrinsics/vcmpcsq_n_u8.c
@@ -1,21 +1,51 @@
 /* { dg-require-effective-target arm_v8_1m_mve_ok } */
 /* { dg-add-options arm_v8_1m_mve } */
 /* { dg-additional-options "-O2" } */
+/* { dg-final { check-function-bodies "**" "" } } */
 
 #include "arm_mve.h"
 
+/*
+**foo:
+**	...
+**	vcmp.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo (uint8x16_t a, uint8_t b)
 {
   return vcmpcsq_n_u8 (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u8"  }  } */
 
+/*
+**foo1:
+**	...
+**	vcmp.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
 mve_pred16_t
 foo1 (uint8x16_t a, uint8_t b)
 {
   return vcmpcsq (a, b);
 }
 
-/* { dg-final { scan-assembler "vcmp.u8"  }  } */
+/*
+**foo2:
+**	...
+**	vcmp.u8	cs, q[0-9]+, (?:ip|fp|r[0-9]+)(?:	@.*|)
+**	...
+**	vmrs	(?:ip|fp|r[0-9]+), p0(?:	@.*|)
+**	...
+*/
+mve_pred16_t
+foo2 (uint8x16_t a)
+{
+  return vcmpcsq (a, 1);
+}
+
+/* { dg-final { scan-assembler-not "__ARM_undef" } } */
\ No newline at end of file
